/**
 *
 * SKGroupItem.h SK`pO[vNX
 *
 */

#include "GroupItem.h"
#include "SKShortcutItem.h"


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// 萔
//

#define PI				(3.141593)	// ~
#define ICON_OFFSET		(16)		// ACR̕`ʒuItZbg
#define LEVEL_SPACE_NUM	(2)			// XMLɏo͂ۂ̃^ũXy[X


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// vg^Cv錾
//

// XMLp̃^O擾
string convertTag(string key, string value, int level);


/**
 * O[vNX SKGroupItem
 */
class SKGroupItem: public GroupItem {
private:
	// o /////////////////////////

	// LvV
	// Rg
	// ACe
	
	vector<SKShortcutItem> m_item;	// ACe
	UINT m_index;					// IĂACeCfbNX
	int m_keyChar;					// WvL[
	char m_keyShift;				// WvL[Vtg

	// \bh /////////////////////////
	
	// getFromXML̃Tu[`
	const string subStrXML(const string& word, const string& data, UINT posStt, UINT posEnd) const;

public:
	// Getter /////////////////////////

	const UINT getItemIndex() const;					// IĂACeCfbNX
	const int getKeyChar() const;						// WvL[
	const char getKeyShift() const;						// WvL[Vtg
	const vector<SKShortcutItem>& getItem() const;		// ACe

	// Setter /////////////////////////

	void setItemIndex(const UINT arg);	// IĂACeCfbNX
	void setKeyChar(const int arg);		// WvL[
	void setKeyShift(const char arg);	// WvL[Vtg

	
	// J\bh /////////////////////////

	// RXgN^
	SKGroupItem();
	// fXgN^
	~SKGroupItem();

	// Rs[RXgN^
	SKGroupItem(const SKGroupItem& other);
	// Zq
	SKGroupItem& operator=(const SKGroupItem& other);
	
	// ACe擾
	const SKShortcutItem& item(const int i) const;
	
	// IĂACe擾
	const SKShortcutItem& selectedItem() const;
	
	// ACe̐
	const int size() const;
	
	// ACeǉ
	const bool add(const SKShortcutItem& item);
	const bool add(const SKShortcutItem& item, int index);
	
	// ACe폜
	const bool remove(int index);

	// SACe폜
	const bool clear();

	// XML擾
	const bool getFromXML(const string& data);

	// XMLɕϊ
	const string convXML(int level);

	// ACëʒu𐮓
	const void orderIcon(const bool autoR, int minR, int maxR, int iconInterval);

	// ACëʒu𓮂
	const void moveIcon(const float r, const float theta);
	// ACëʒu𓮂`
	const void moveDrawIcon(HWND hWnd, HRGN invalidRgn, LPPOINT center, bool bNewArea, float r, float theta);

	// SACẽACR`
	const void drawIcon(const HDC hDC, const LPPOINT center) const;
};


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// RXgN^
//
inline SKGroupItem::SKGroupItem()
{
	// string^͑Sċ󕶎, vector͋zŏ

	m_index = 0;					// IĂACeCfbNX
	m_keyChar = 0;					// WvL[
	m_keyShift = 0;					// WvL[Vtg
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// fXgN^
//
inline SKGroupItem::~SKGroupItem()
{
	m_item.clear();
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// Rs[RXgN^
//
inline SKGroupItem::SKGroupItem(const SKGroupItem& other)
{
	string caption(other.getCaption());
	m_caption.assign(caption);

	string comment(other.getComment());
	m_comment.assign(comment);

	m_index = 0;
	m_keyChar = other.getKeyChar();
	m_keyShift = other.getKeyShift();

	// ACe
	vector<SKShortcutItem> item(other.getItem());
	m_item.assign(item.begin(), item.end());
}


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// Zq
//
inline SKGroupItem& SKGroupItem::operator=(const SKGroupItem& other)
{
	string caption(other.getCaption());
	m_caption.assign(caption);

	string comment(other.getComment());
	m_comment.assign(comment);

	m_index = 0;
	m_keyChar = other.getKeyChar();
	m_keyShift = other.getKeyShift();

	// ACe
	vector<SKShortcutItem> item(other.getItem());
	m_item.assign(item.begin(), item.end());
	return(*this);
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Getter
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// IĂACeCfbNX
inline const UINT SKGroupItem::getItemIndex() const
{
	return m_index;
}

// WvL[
inline const int SKGroupItem::getKeyChar() const
{
	return m_keyChar;
}

// WvL[Vtg
inline const char SKGroupItem::getKeyShift() const
{
	return m_keyShift;
}
// ACe
inline const vector<SKShortcutItem>& SKGroupItem::getItem() const
{
	return m_item;
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Setter
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// IĂACeCfbNX
inline void SKGroupItem::setItemIndex(const UINT arg)
{
	// ͈͓ǂ
	if(!m_item.empty() && arg >= 0 && arg < m_item.size())
		m_index = arg;
}

// WvL[
inline void SKGroupItem::setKeyChar(const int arg)
{
	m_keyChar = arg;
}

// WvL[Vtg
inline void SKGroupItem::setKeyShift(const char arg)
{
	m_keyShift = arg;
}


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// ACe擾
//
inline const SKShortcutItem& SKGroupItem::item(const int i) const
{
	return m_item.at(i);
}


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// IĂACe擾
//
inline const SKShortcutItem& SKGroupItem::selectedItem() const
{
	return m_item.at(m_index);
}


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// ACe̐
//
inline const int SKGroupItem::size() const
{
	return m_item.size();
}


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// ACeǉ
//
inline const bool SKGroupItem::add(const SKShortcutItem& item)
{
	m_item.push_back(item);
	return true;
}

inline const bool SKGroupItem::add(const SKShortcutItem& item, int index)
{
	// index𔻒
	if(index > 0 && index < m_item.size()){
		// indeẍʒuɑ}
		m_item.insert(m_item.begin() + index + 1, item);
		return true;

	}else if(index == m_item.size()){
		// ɑ}
		m_item.push_back(item);
		return true;

	}else{
		return false;
	}
}


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// ACe폜
//
inline const bool SKGroupItem::remove(int index)
{
	// index𔻒
	if(index > 0 && index < m_item.size()-1){
		// indeẍʒu̗vf폜
		m_item.erase(m_item.begin() + index);
		return true;

	}else if(index == m_item.size()-1){
		// Ō̗vf폜
		m_item.pop_back();
		return true;

	}else{
		return false;
	}
}


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// SACe폜
//
inline const bool SKGroupItem::clear()
{
	m_item.clear();
	return true;
}


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// ACëʒu𓮂
//
inline const void SKGroupItem::moveIcon(float r, float theta)
{
	int size = m_item.size();

	for(int i=0; i<size; i++){
		m_item.at(i).addLoacation(r, theta);
	}
}


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// ACëʒu𓮂`
//
inline const void SKGroupItem::moveDrawIcon(HWND hWnd, HRGN invalidRgn, LPPOINT center, bool bNewArea, float r, float theta)
{
	int size = m_item.size();
	int x, y, cx, cy, ix, iy;
	HRGN addRgn;

	cx = (int)center->x - ICON_OFFSET;
	cy = (int)center->y - ICON_OFFSET;

	for(int i=0; i<size; i++){
		// ACe̒SW
		x = center->x + m_item.at(i).getX();
		y = center->y + m_item.at(i).getY();
		// ǉ͈
		addRgn = CreateRectRgn(x - 16, y - 16, x + 16, y + 16);
		// ĕ`͈͂ɃvX
		CombineRgn(invalidRgn, invalidRgn, addRgn, RGN_OR);
		// svȃ[W폜
		DeleteObject(addRgn);

		m_item.at(i).addLoacation(r, theta);	// ړ

		ix = m_item.at(i).getX();				// ړ
		iy = m_item.at(i).getY();

		if(bNewArea){
			// ړ̍W
			x = center->x + ix;
			y = center->y + iy;
			// ǉ͈
			addRgn = CreateRectRgn(x - 16, y - 16, x + 16, y + 16);
			// ĕ`͈͂ɃvX
			CombineRgn(invalidRgn, invalidRgn, addRgn, RGN_OR);
			// svȃ[W폜
			DeleteObject(addRgn);
		}
	}
}


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// ACëʒu𐮓
//
inline const void SKGroupItem::orderIcon(const bool autoR, int minR, int maxR, int iconInterval)
{
	int size = m_item.size();
	float r;

	// (r, ۂ̒l)=(0, 50)`(100, 550)
	minR = minR*5+50;
	maxR = maxR*5+50;

	if(autoR){
		// (iconInterval, ۂ̒l)=(0, 10)`(100, 310)
		iconInterval = iconInterval*3+10;
		r = iconInterval / sin(PI / size);
		if(r < minR) r = minR;
		if(r > maxR) r = maxR;
	}else{
		r = minR;
	}

	for(int i=0; i<size; i++){
		float theta = 2*PI * i/size + PI*3/2;
		m_item.at(i).setLoacation(r, theta);
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// XML擾
//
inline const bool SKGroupItem::getFromXML(const string& data)
{
	UINT posStt, posEnd;
	string buff;

	// posStt, posEnd̐ݒ
	posStt = data.find("<GroupItem>", 0);
	if(posStt == string::npos) return false;	// Ȃꍇs
	buff = "</GroupItem>";
	posEnd = data.find(buff, 0);
	if(posEnd == string::npos) return false;	// Ȃꍇs
	posEnd += buff.length();

	// LvV
	buff = subStrXML("Caption", data, posStt, posEnd);
	if(buff != "")	m_caption = buff;
	else			return false;		// K{
	// Rg
	buff = subStrXML("Comment", data, posStt, posEnd);
	if(buff != "")	m_comment = buff;
	else			m_comment = "";
	// WvL[
	buff = subStrXML("KeyChar", data, posStt, posEnd);
	if(buff != "")	m_keyChar = atoi(buff.c_str());
	else			m_keyChar = 0;
	// WvL[Vtg
	buff = subStrXML("KeyShift", data, posStt, posEnd);
	if(buff != "")	m_keyShift = atoi(buff.c_str());
	else			m_keyShift = 0;

	// V[gJbgACe̎擾
	int pos1=posStt, pos2=posStt;

	while(1){
		// pos1, pos2̐ݒ
		pos1 = data.find("<ShortcutItem>", pos2);
		if(pos1 == string::npos) break;			// ȂꍇI
		buff = "</ShortcutItem>";
		pos2 = data.find(buff, pos1);
		if(pos2 == string::npos) return false;	// Ȃꍇs
		pos2 += buff.length();

		SKShortcutItem item;
		if( !item.getFromXML(data.substr(pos1, pos2-pos1)) ){
			m_item.clear();
			return false;
		}

		m_item.push_back(item);
	}

	// ACeȂ琬
	if(!m_item.empty())	return true;
	else				return false;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// getFromXML̃Tu[`
//
inline const string SKGroupItem::subStrXML(const string& word, const string& data, UINT posStt, UINT posEnd) const
{
	UINT pos1, pos2;

	// {<word}  {>} ̌
	pos1 = data.find("<" + word, posStt);
	if(pos1 == string::npos) return "";	// ȂȂ玸s
	pos2 = data.find(">", pos1);
	if(pos2 == string::npos) return "";	// ȂȂ玸s

	// {<word>`</word>} 𔻒f
	if( data.substr(pos2-1, 1).compare("/") != 0 && pos2 < posEnd){
		pos1 = pos2 + 1;
		pos2 = data.find("</" + word + ">", pos1);
		
		if(pos1 == pos2) return "";	// 󕶎Ȃ玸s

		return data.substr(pos1, pos2 - pos1);

	}else return "";
}


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// XMLɕϊ
//
inline const string SKGroupItem::convXML(int level)
{
	string ret;
	int level1 = level+1, level2 = level+2;

	// <GroupItem>
	ret.append(string(level*LEVEL_SPACE_NUM,' ') + "<GroupItem>\n");

	// O[ṽvpeB
	ret.append(convertTag("Caption",	m_caption, level1));
	ret.append(convertTag("Comment",	m_comment, level1));
	ret.append(convertTag("KeyChar",	itoa(m_keyChar, NULL, 10), level1));
	ret.append(convertTag("KeyShift",	itoa(m_keyShift, NULL, 10), level1));

	// ACe
	int size=m_item.size();
	for(int i=0; i<size; i++){
		SKShortcutItem& item = m_item.at(i);

		// <ShortcutItem>
		ret.append(string(level1*LEVEL_SPACE_NUM,' ') + "<ShortcutItem>\n");

		// ACẽvpeB
		ret.append(convertTag("Caption",	item.getCaption(), level2));
		ret.append(convertTag("Comment",	item.getComment(), level2));
		ret.append(convertTag("Path",		item.getPath(), level2));
		ret.append(convertTag("DirPath",	item.getDirPath(), level2));
		ret.append(convertTag("Param",		item.getParameter(), level2));
		ret.append(convertTag("ShowCmd",	itoa(item.getShowCmd(), NULL, 10), level2));
		ret.append(convertTag("IconPath",	item.getIconPath(), level2));
		ret.append(convertTag("IconIndex",	itoa(item.getIconIndex(), NULL, 10), level2));
		ret.append(convertTag("KeyChar",	itoa(item.getKeyChar(), NULL, 10), level2));
		ret.append(convertTag("KeyShift",	itoa(item.getKeyShift(), NULL, 10), level2));

		// </ShortcutItem>
		ret.append(string(level1*LEVEL_SPACE_NUM,' ') + "</ShortcutItem>\n");
	}

	// </GroupItem>
	ret.append(string(level*LEVEL_SPACE_NUM,' ') + "</GroupItem>\n");

	return ret;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// XMLp̃^O擾
//
string convertTag(string key, string value, int level)
{
	string ret(level * LEVEL_SPACE_NUM, ' ');

	if( value.empty() )	ret.append("<" + key + " />");
	else				ret.append("<" + key + ">" + value + "</" + key + ">\n");

	return ret;
}


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// SACẽACR`
//
inline const void SKGroupItem::drawIcon(const HDC hDC, const LPPOINT center) const
{
	int x, y, cx, cy;
	int size = m_item.size();

	cx = (int)center->x - ICON_OFFSET;
	cy = (int)center->y - ICON_OFFSET;

	for(int i=0; i<size; i++){
		// Wݒ
		x = cx + m_item.at(i).getX();
		y = cy + m_item.at(i).getY();

		// `
		DrawIcon( hDC, x, y, m_item.at(i).getHIcon() );
	}
}

